Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveGenerator.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveGenerator.cs	(revision 9495)
@@ -42,6 +42,6 @@
       get { return (ILookupParameter<MultiComponentVectorEncoding>)Parameters["MultiComponentVector"]; }
     }
-    public ILookupParameter<MultiComponentVectorMove> MultiComponentVectorMoveParameter {
-      get { return (LookupParameter<MultiComponentVectorMove>)Parameters["MultiComponentVectorMove"]; }
+    public ILookupParameter<IPackingMove> PackingMoveParameter {
+      get { return (LookupParameter<IPackingMove>)Parameters["PackingMove"]; }
     }
     protected ScopeParameter CurrentScopeParameter {
@@ -56,5 +56,5 @@
       : base() {
         Parameters.Add(new LookupParameter<MultiComponentVectorEncoding>("MultiComponentVector", "The multi component vector for which moves should be generated."));
-      Parameters.Add(new LookupParameter<MultiComponentVectorMove>("MultiComponentVectorMove", "The moves that should be generated in subscopes."));
+        Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The moves that should be generated in subscopes."));
       Parameters.Add(new ScopeParameter("CurrentScope", "The current scope where the moves should be added as subscopes."));
     }
@@ -62,96 +62,49 @@
 
     public static int NrOfRotationMoves(MultiComponentVectorEncoding mcv) {
-      return mcv.PackingInformations.Count;
+      return mcv.NrOfItems;
     }
     public static IEnumerable<MultiComponentVectorMove> GenerateRotationMoves(MultiComponentVectorEncoding multiComponentVector) {
-      for (int i = 0; i < multiComponentVector.PackingInformations.Count; i++)
-        yield return new SingleItemRotationMove(i, multiComponentVector);
+      for (int binNr = 0; binNr < multiComponentVector.PackingInformations.Count; binNr++)
+        for (int index = 0; index < multiComponentVector.PackingInformations[binNr].Count; index++)
+          yield return new SingleItemRotationMove(binNr, index, multiComponentVector);
     }
 
     public static int NrOfSingleGroupingMoves(MultiComponentVectorEncoding mcv) {
-      int nrOfBins = 0;
-      foreach (var pi in mcv.PackingInformations) {
-        if (pi.AssignedBin > nrOfBins)
-          nrOfBins = pi.AssignedBin;
-      }
-      nrOfBins++;
-      return mcv.PackingInformations.Count * (nrOfBins - 1);
+      return mcv.NrOfItems * (mcv.NrOfBins - 1);
     }
     public static IEnumerable<MultiComponentVectorMove> GenerateSingleGroupingMoves(MultiComponentVectorEncoding multiComponentVector) {
-      int nrOfBins = 0;
-      foreach (var pi in multiComponentVector.PackingInformations) {
-        if (pi.AssignedBin > nrOfBins)
-          nrOfBins = pi.AssignedBin;
-      }
-      nrOfBins++;
-      for (int i = 0; i < multiComponentVector.PackingInformations.Count; i++)
-        for (int j = 0; j < nrOfBins; j++) {
-          if (j != multiComponentVector.PackingInformations[i].AssignedBin)
-            yield return new SingleGroupingMove(i, j, multiComponentVector);
-        }
+      for (int oldBin = 0; oldBin < multiComponentVector.PackingInformations.Count; oldBin++)
+        for (int index = 0; index < multiComponentVector.PackingInformations[oldBin].Count; index++)
+          for (int newBin = 0; newBin < multiComponentVector.NrOfBins; newBin++) 
+            if (newBin != oldBin)
+              yield return new SingleGroupingMove(oldBin, index, newBin, multiComponentVector);
     }
 
     public static int NrOfSwapPositionMoves(MultiComponentVectorEncoding mcv) {
-      int nrOfBins = 0;
-      foreach (var pi in mcv.PackingInformations) {
-        if (pi.AssignedBin > nrOfBins)
-          nrOfBins = pi.AssignedBin;
-      }
-      nrOfBins++;
-      int[] itemsPerBin = new int[nrOfBins];
-      foreach (var pi in mcv.PackingInformations) {
-        itemsPerBin[pi.AssignedBin]++;
-      }
       int nrOfSwapPositionMoves = 0;
-      foreach (int items in itemsPerBin) {
-        nrOfSwapPositionMoves += (items * (items - 1)) / 2;
+      foreach (var groupInformations in mcv.PackingInformations) {
+        nrOfSwapPositionMoves += (groupInformations.Value.Count * (groupInformations.Value.Count - 1)) / 2;
       }
       return nrOfSwapPositionMoves;
     }
     public static IEnumerable<MultiComponentVectorMove> GenerateSwapPositionMoves(MultiComponentVectorEncoding multiComponentVector) {
-      Dictionary<int, List<int>> indexesPerBin = new Dictionary<int, List<int>>();
-      for (int i = 0; i < multiComponentVector.PackingInformations.Count; i++) {
-        int currentBin = multiComponentVector.PackingInformations[i].AssignedBin;
-        if (!indexesPerBin.ContainsKey(currentBin))
-          indexesPerBin[currentBin] = new List<int>();
-        indexesPerBin[currentBin].Add(i);
-      }
-      foreach (var entry in indexesPerBin) {
-        for (int i = 0; i < entry.Value.Count - 1; i++)
-          for (int j = i + 1; j < entry.Value.Count; j++)
-            yield return new SwapPositionMove(entry.Value[i], entry.Value[j], multiComponentVector);
-      }
+      for (int bin = 0; bin < multiComponentVector.PackingInformations.Count; bin++)
+        for (int oldIndex = 0; oldIndex < multiComponentVector.PackingInformations[bin].Count - 1; oldIndex++) 
+          for (int newIndex = oldIndex + 1; newIndex < multiComponentVector.PackingInformations[bin].Count; newIndex++)
+            yield return new SwapPositionMove(bin, oldIndex, newIndex, multiComponentVector);
     }
 
     public static int NrOfChangePositionMoves(MultiComponentVectorEncoding mcv) {
-      int nrOfBins = 0;
-      foreach (var pi in mcv.PackingInformations) {
-        if (pi.AssignedBin > nrOfBins)
-          nrOfBins = pi.AssignedBin;
+      int nrOfChangePositionMoves = 0;
+      foreach (var groupInformations in mcv.PackingInformations) {
+        nrOfChangePositionMoves += (groupInformations.Value.Count * (groupInformations.Value.Count - 1)) / 2;
       }
-      nrOfBins++;
-      int[] itemsPerBin = new int[nrOfBins];
-      foreach (var pi in mcv.PackingInformations) {
-        itemsPerBin[pi.AssignedBin]++;
-      }
-      int nrOfSwapPositionMoves = 0;
-      foreach (int items in itemsPerBin) {
-        nrOfSwapPositionMoves += (items * (items - 1)) / 2;
-      }
-      return nrOfSwapPositionMoves;
+      return nrOfChangePositionMoves;
     }
     public static IEnumerable<MultiComponentVectorMove> GenerateChangePositionMoves(MultiComponentVectorEncoding multiComponentVector) {
-      Dictionary<int, List<int>> indexesPerBin = new Dictionary<int, List<int>>();
-      for (int i = 0; i < multiComponentVector.PackingInformations.Count; i++) {
-        int currentBin = multiComponentVector.PackingInformations[i].AssignedBin;
-        if (!indexesPerBin.ContainsKey(currentBin))
-          indexesPerBin[currentBin] = new List<int>();
-        indexesPerBin[currentBin].Add(i);
-      }
-      foreach (var entry in indexesPerBin) {
-        for (int i = 0; i < entry.Value.Count - 1; i++)
-          for (int j = i + 1; j < entry.Value.Count; j++)
-            yield return new ChangePositionMove(entry.Value[i], entry.Value[j], multiComponentVector);
-      }
+      for (int bin = 0; bin < multiComponentVector.PackingInformations.Count; bin++)
+        for (int oldIndex = 0; oldIndex < multiComponentVector.PackingInformations[bin].Count - 1; oldIndex++) 
+          for (int newIndex = oldIndex + 1; newIndex < multiComponentVector.PackingInformations[bin].Count; newIndex++)
+            yield return new ChangePositionMove(bin, oldIndex, newIndex, multiComponentVector);
     }
 
@@ -162,5 +115,5 @@
       for (int i = 0; i < moveScopes.Length; i++) {
         moveScopes[i] = new Scope(i.ToString());
-        moveScopes[i].Variables.Add(new Variable(MultiComponentVectorMoveParameter.ActualName, moves[i]));
+        moveScopes[i].Variables.Add(new Variable(PackingMoveParameter.ActualName, moves[i]));
       }
       CurrentScopeParameter.ActualValue.SubScopes.AddRange(moveScopes);
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveHardTabuCriterion.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveHardTabuCriterion.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveHardTabuCriterion.cs	(revision 9495)
@@ -38,6 +38,6 @@
       get { return false; }
     }
-    public ILookupParameter<MultiComponentVectorMove> MultiComponentVectorMoveParameter {
-      get { return (ILookupParameter<MultiComponentVectorMove>)Parameters["MultiComponentVectorMove"]; }
+    public ILookupParameter<IPackingMove> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
     }
     public ILookupParameter<MultiComponentVectorEncoding> MultiComponentVectorParameter {
@@ -65,5 +65,5 @@
     public MultiComponentVectorMoveHardTabuCriterion()
       : base() {
-        Parameters.Add(new LookupParameter<MultiComponentVectorMove>("MultiComponentVectorMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
       Parameters.Add(new LookupParameter<MultiComponentVectorEncoding>("MultiComponentVector", "The solution to evaluate."));
       Parameters.Add(new LookupParameter<BoolValue>("MoveTabu", "The variable to store if a move was tabu."));
@@ -80,5 +80,5 @@
     public override IOperation Apply() {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
-      MultiComponentVectorMove move = MultiComponentVectorMoveParameter.ActualValue;
+      MultiComponentVectorMove move = PackingMoveParameter.ActualValue as MultiComponentVectorMove;
       MultiComponentVectorEncoding multiComponentVector = MultiComponentVectorParameter.ActualValue;
       int length = multiComponentVector.PackingInformations.Count;
@@ -94,93 +94,17 @@
     private bool IsMoveTabu(ItemList<IItem> tabuList, MultiComponentVectorMove move, MultiComponentVectorEncoding multiComponentVector, double moveQuality, bool maximization, bool useAspiration) {
       bool isTabu = false;
-      SingleItemRotationMove sirm = move as SingleItemRotationMove;
-      SingleGroupingMove sgm = move as SingleGroupingMove;
-      SwapPositionMove spm = move as SwapPositionMove;
-      ChangePositionMove cpm = move as ChangePositionMove;
-      MCVTripleMove tm = move as MCVTripleMove;
       var attributes = tabuList.FindAll(ta => ta.GetType().Equals(move.GetMoveAttributeType()));
 
-      if (sirm != null) {
-        foreach (IItem tabuMove in attributes) {
-          SingleItemRotationMoveAttribute sirmAttr = (tabuMove as SingleItemRotationMoveAttribute);
-          if (sirmAttr.MoveQuality.Equals(moveQuality))
-            return true;
-          if (sirmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= sirmAttr.MoveQuality
-                || !maximization && moveQuality >= sirmAttr.MoveQuality)) {
-                  if (sirm.ItemIndex == sirmAttr.ItemIndex || multiComponentVector.PackingInformations[sirm.ItemIndex].Rotated == sirmAttr.ItemRotation)
-                    isTabu = true;
-          }
-          if (isTabu) break;
+      foreach (IItem attr in attributes) {
+        MultiComponentVectorMoveAttribute mcvAttr = attr as MultiComponentVectorMoveAttribute;
+        if (mcvAttr != null
+          && (!useAspiration
+              || maximization && moveQuality <= mcvAttr.MoveQuality
+              || !maximization && moveQuality >= mcvAttr.MoveQuality)) {
+
+          isTabu = move.BelongsToAttribute(mcvAttr, true);
         }
-      } else if (sgm != null) {
-        foreach (IItem tabuMove in attributes) {
-          SingleGroupingMoveAttribute sgmAttr = (tabuMove as SingleGroupingMoveAttribute);
-          if (sgmAttr.MoveQuality.Equals(moveQuality))
-            return true;
-          if (sgmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= sgmAttr.MoveQuality
-                || !maximization && moveQuality >= sgmAttr.MoveQuality)) {
-                  if ( multiComponentVector.PackingInformations[sgm.Index].ItemIndex ==  multiComponentVector.PackingInformations[sgmAttr.Index].ItemIndex
-                    || multiComponentVector.PackingInformations[sgm.Index].AssignedBin == sgmAttr.AssignedBin)
-                    isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } else if (spm != null) {
-        foreach (IItem tabuMove in attributes) {
-          SwapPositionMoveAttribute spmAttr = (tabuMove as SwapPositionMoveAttribute);
-          if (spmAttr.MoveQuality.Equals(moveQuality))
-            return true;
-          if (spmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= spmAttr.MoveQuality
-                || !maximization && moveQuality >= spmAttr.MoveQuality)) {
-            if (spm.Index1 == spmAttr.Index1
-              || spm.Index2 == spmAttr.Index2
-              || multiComponentVector.PackingInformations[spm.Index1].ItemIndex == spmAttr.ItemIndex1
-              || multiComponentVector.PackingInformations[spm.Index2].ItemIndex == spmAttr.ItemIndex2)
-              isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } else if (cpm != null) {
-        foreach (IItem tabuMove in attributes) {
-          ChangePositionMoveAttribute cpmAttr = (tabuMove as ChangePositionMoveAttribute);
-          if (cpmAttr.MoveQuality.Equals(moveQuality))
-            return true;
-          if (cpmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= cpmAttr.MoveQuality
-                || !maximization && moveQuality >= cpmAttr.MoveQuality)) {
-            if (cpm.Index == cpmAttr.Index
-        || cpm.TargetIndex == cpmAttr.TargetIndex
-        || multiComponentVector.PackingInformations[cpm.Index].ItemIndex == cpmAttr.ItemIndex)
-              isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } else if (tm != null) {
-        foreach (IItem tabuMove in attributes) {
-          MCVTripleMoveAttribute tmAttr = (tabuMove as MCVTripleMoveAttribute);
-          if (tmAttr.MoveQuality.Equals(moveQuality))
-            return true;
-          if (tmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= tmAttr.MoveQuality
-                || !maximization && moveQuality >= tmAttr.MoveQuality)) {
-                  if ((tm.Index == tmAttr.Index && tm.TargetIndex == tmAttr.TargetIndex)
-                      || tm.Index == tmAttr.Index
-                      || multiComponentVector.PackingInformations[tm.Index].ItemIndex == tmAttr.ItemIndex
-                    )
-              isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } 
-
-      
+        if (isTabu) break;
+      }
 
       return isTabu;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveMaker.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveMaker.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveMaker.cs	(revision 9495)
@@ -42,9 +42,15 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["MoveQuality"]; }
     }
-    public ILookupParameter<MultiComponentVectorMove> MultiComponentVectorMoveParameter {
-      get { return (ILookupParameter<MultiComponentVectorMove>)Parameters["MultiComponentVectorMove"]; }
+    public ILookupParameter<IPackingMove> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
     }
     public ILookupParameter<MultiComponentVectorEncoding> MultiComponentVectorParameter {
       get { return (ILookupParameter<MultiComponentVectorEncoding>)Parameters["MultiComponentVector"]; }
+    }
+    public ILookupParameter<IPackingPlan> PackingPlanParameter {
+      get { return (ILookupParameter<IPackingPlan>)Parameters["PackingPlan"]; }
+    }
+    public ILookupParameter<IPackingPlan> PackingPlanAfterMoveParameter {
+      get { return (ILookupParameter<IPackingPlan>)Parameters["PackingPlanAfterMove"]; }
     }
 
@@ -55,7 +61,9 @@
       : base() {
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the solution."));
-      Parameters.Add(new LookupParameter<MultiComponentVectorMove>("MultiComponentVectorMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
       Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The relative quality of the move."));
       Parameters.Add(new LookupParameter<MultiComponentVectorEncoding>("MultiComponentVector", "The solution as grouping vector."));
+      Parameters.Add(new LookupParameter<IPackingPlan>("PackingPlan", "The currently best performing, decoded bin-packing solution represented as generalized packing-plan."));
+      Parameters.Add(new LookupParameter<IPackingPlan>("PackingPlanAfterMove", "The moved and decoded bin-packing solution represented as generalized packing-plan."));
     }
 
@@ -65,10 +73,11 @@
 
     public override IOperation Apply() {
-      MultiComponentVectorMove move = MultiComponentVectorMoveParameter.ActualValue;
+      IPackingMove move = PackingMoveParameter.ActualValue;
       MultiComponentVectorEncoding multiComponentVector = MultiComponentVectorParameter.ActualValue;
       DoubleValue moveQuality = MoveQualityParameter.ActualValue;
       DoubleValue quality = QualityParameter.ActualValue;
 
-      multiComponentVector.PackingInformations = move.GetVectorAfterMove().PackingInformations;
+      multiComponentVector.PackingInformations = (move.GetSolutionAfterMove() as MultiComponentVectorEncoding).PackingInformations;
+      PackingPlanParameter.ActualValue = PackingPlanAfterMoveParameter.ActualValue;
 
       quality.Value = moveQuality.Value;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveSoftTabuCriterion.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveSoftTabuCriterion.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveSoftTabuCriterion.cs	(revision 9495)
@@ -38,6 +38,6 @@
       get { return false; }
     }
-    public ILookupParameter<MultiComponentVectorMove> MultiComponentVectorMoveParameter {
-      get { return (ILookupParameter<MultiComponentVectorMove>)Parameters["MultiComponentVectorMove"]; }
+    public ILookupParameter<IPackingMove> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
     }
     public ILookupParameter<MultiComponentVectorEncoding> MultiComponentVectorParameter {
@@ -65,5 +65,5 @@
     public MultiComponentVectorMoveSoftTabuCriterion()
       : base() {
-      Parameters.Add(new LookupParameter<MultiComponentVectorMove>("MultiComponentVectorMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
       Parameters.Add(new LookupParameter<MultiComponentVectorEncoding>("MultiComponentVector", "The solution to evaluate."));
       Parameters.Add(new LookupParameter<BoolValue>("MoveTabu", "The variable to store if a move was tabu."));
@@ -80,5 +80,5 @@
     public override IOperation Apply() {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
-      MultiComponentVectorMove move = MultiComponentVectorMoveParameter.ActualValue;
+      MultiComponentVectorMove move = PackingMoveParameter.ActualValue as MultiComponentVectorMove;
       MultiComponentVectorEncoding multiComponentVector = MultiComponentVectorParameter.ActualValue;
       int length = multiComponentVector.PackingInformations.Count;
@@ -94,85 +94,17 @@
     private bool IsMoveTabu(ItemList<IItem> tabuList, MultiComponentVectorMove move, MultiComponentVectorEncoding multiComponentVector, double moveQuality, bool maximization, bool useAspiration) {
       bool isTabu = false;
-
-      SingleItemRotationMove sirm = move as SingleItemRotationMove;
-      SingleGroupingMove sgm = move as SingleGroupingMove;
-      SwapPositionMove spm = move as SwapPositionMove;
-      ChangePositionMove cpm = move as ChangePositionMove;
-      MCVTripleMove tm = move as MCVTripleMove;
       var attributes = tabuList.FindAll(ta => ta.GetType().Equals(move.GetMoveAttributeType()));
 
-      if (sirm != null) {
-        foreach (IItem tabuMove in attributes) {
-          SingleItemRotationMoveAttribute sirmAttr = (tabuMove as SingleItemRotationMoveAttribute);
-          if (sirmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= sirmAttr.MoveQuality
-                || !maximization && moveQuality >= sirmAttr.MoveQuality)) {
-            if (sirm.ItemIndex == sirmAttr.ItemIndex && multiComponentVector.PackingInformations[sirm.ItemIndex].Rotated == sirmAttr.ItemRotation)
-              isTabu = true;
-          }
-          if (isTabu) break;
+      foreach (IItem attr in attributes) {
+        MultiComponentVectorMoveAttribute mcvAttr = attr as MultiComponentVectorMoveAttribute;
+        if (mcvAttr != null
+          && (!useAspiration
+              || maximization && moveQuality <= mcvAttr.MoveQuality
+              || !maximization && moveQuality >= mcvAttr.MoveQuality)) {
+
+                isTabu = move.BelongsToAttribute(mcvAttr, false);
         }
-      } else if (sgm != null) {
-        foreach (IItem tabuMove in attributes) {
-          SingleGroupingMoveAttribute sgmAttr = (tabuMove as SingleGroupingMoveAttribute);
-          if (sgmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= sgmAttr.MoveQuality
-                || !maximization && moveQuality >= sgmAttr.MoveQuality)) {
-                  if (multiComponentVector.PackingInformations[sgm.Index].ItemIndex == multiComponentVector.PackingInformations[sgmAttr.Index].ItemIndex 
-              && multiComponentVector.PackingInformations[sgm.Index].AssignedBin == sgmAttr.AssignedBin)
-              isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } else if (spm != null) {
-        foreach (IItem tabuMove in attributes) {
-          SwapPositionMoveAttribute spmAttr = (tabuMove as SwapPositionMoveAttribute);
-          if (spmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= spmAttr.MoveQuality
-                || !maximization && moveQuality >= spmAttr.MoveQuality)) {
-            if (spm.Index1 == spmAttr.Index1
-              && spm.Index2 == spmAttr.Index2
-              && multiComponentVector.PackingInformations[spm.Index1].ItemIndex == spmAttr.ItemIndex1
-              && multiComponentVector.PackingInformations[spm.Index2].ItemIndex == spmAttr.ItemIndex2)
-              isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } else if (cpm != null) {
-        foreach (IItem tabuMove in attributes) {
-          ChangePositionMoveAttribute cpmAttr = (tabuMove as ChangePositionMoveAttribute);
-          if (cpmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= cpmAttr.MoveQuality
-                || !maximization && moveQuality >= cpmAttr.MoveQuality)) {
-            if (cpm.Index == cpmAttr.Index
-        && cpm.TargetIndex == cpmAttr.TargetIndex
-        && multiComponentVector.PackingInformations[cpm.Index].ItemIndex == cpmAttr.ItemIndex)
-              isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } else if (tm != null) {
-        foreach (IItem tabuMove in attributes) {
-          MCVTripleMoveAttribute tmAttr = (tabuMove as MCVTripleMoveAttribute);
-          if (tmAttr != null
-            && (!useAspiration
-                || maximization && moveQuality <= tmAttr.MoveQuality
-                || !maximization && moveQuality >= tmAttr.MoveQuality)) {
-            if ((tm.Index == tmAttr.Index && tm.TargetIndex == tmAttr.TargetIndex)
-                && multiComponentVector.PackingInformations[tm.Index].ItemIndex == tmAttr.ItemIndex
-                && tm.Rotation == !(tmAttr.RotationAfter.Equals(tmAttr.RotationBefore))
-                && (tm.Group == tmAttr.GroupAfter && multiComponentVector.PackingInformations[tm.Index].AssignedBin == tmAttr.GroupBefore)
-              )
-              isTabu = true;
-          }
-          if (isTabu) break;
-        }
-      } 
-
-
+        if (isTabu) break;
+      }
 
       return isTabu;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorTabuMaker.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorTabuMaker.cs	(revision 9494)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorTabuMaker.cs	(revision 9495)
@@ -32,6 +32,6 @@
   [StorableClass]
   public class MultiComponentVectorTabuMaker : TabuMaker, IMultiComponentVectorMoveOperator{
-    public ILookupParameter<MultiComponentVectorMove> MultiComponentVectorMoveParameter {
-      get { return (ILookupParameter<MultiComponentVectorMove>)Parameters["MultiComponentVectorMove"]; }
+    public ILookupParameter<IPackingMove> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
     }
     public ILookupParameter<MultiComponentVectorEncoding> MultiComponentVectorParameter {
@@ -44,5 +44,5 @@
     public MultiComponentVectorTabuMaker()
       : base() {
-      Parameters.Add(new LookupParameter<MultiComponentVectorMove>("MultiComponentVectorMove", "The move to evaluate."));
+        Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
       Parameters.Add(new LookupParameter<MultiComponentVectorEncoding>("MultiComponentVector", "The solution to evaluate."));
     }
@@ -53,5 +53,5 @@
 
     protected override IItem GetTabuAttribute(bool maximization, double quality, double moveQuality) {
-      MultiComponentVectorMove move = MultiComponentVectorMoveParameter.ActualValue;
+      IPackingMove move = PackingMoveParameter.ActualValue;
       MultiComponentVectorEncoding solution = MultiComponentVectorParameter.ActualValue;
       double baseQuality = moveQuality;
@@ -59,28 +59,7 @@
         baseQuality = quality; // we make an uphill move, the lower bound is the solution quality
                               
-      SingleItemRotationMove sirm = move as SingleItemRotationMove;
-      if (sirm != null)
-        return new SingleItemRotationMoveAttribute(sirm.ItemIndex, solution.PackingInformations[sirm.ItemIndex].Rotated, baseQuality);
-      SingleGroupingMove sgm = move as SingleGroupingMove;
-      if (sgm != null)
-        return new SingleGroupingMoveAttribute(sgm.Index, solution.PackingInformations[sgm.Index].AssignedBin, baseQuality);
-      SwapPositionMove spm = move as SwapPositionMove;
-      if (spm != null)
-        return new SwapPositionMoveAttribute(spm.Index1, spm.Index2, solution.PackingInformations[spm.Index1].ItemIndex, solution.PackingInformations[spm.Index2].ItemIndex, baseQuality);
-      ChangePositionMove cpm = move as ChangePositionMove;
-      if (cpm != null)
-        return new ChangePositionMoveAttribute(cpm.Index, cpm.TargetIndex, solution.PackingInformations[cpm.Index].ItemIndex, baseQuality);
-      MCVTripleMove tm = move as MCVTripleMove;
-      if (tm != null)
-        return new MCVTripleMoveAttribute(
-          tm.Index, 
-          tm.TargetIndex,
-          solution.PackingInformations[tm.Index].ItemIndex,
-          solution.PackingInformations[tm.Index].Rotated,
-          tm.Rotation ^ solution.PackingInformations[tm.Index].Rotated,
-          solution.PackingInformations[tm.Index].AssignedBin,
-          tm.Group,
-          baseQuality);
-
+      MultiComponentVectorMove mcvMove = move as MultiComponentVectorMove;
+      if (mcvMove != null)
+        return mcvMove.GetAttribute(baseQuality);
       else return solution;
     }
